/* f2c.h  --  Standard Fortran to C header file */

/**  barf  [ba:rf]  2.  "He suggested using FORTRAN, and everybody barfed."

	- From The Shogakukan DICTIONARY OF NEW ENGLISH (Second edition) */
#include <math.h>
#include <signal.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <stdio.h>
#include "ctype.h"


namespace LinAlg {

#define Sigarg ...
#define Use_Sigarg


#ifndef F2C_INCLUDE
#define F2C_INCLUDE

typedef long int CLAPACK_integer;
typedef unsigned long CLAPACK_uinteger;
typedef char *address;
typedef short int CLAPACK_shortint;
typedef float CLAPACK_real;
typedef double CLAPACK_doublereal;
typedef struct { CLAPACK_real r, i; } CLAPACK_complex;
typedef struct { CLAPACK_doublereal r, i; } CLAPACK_doublecomplex;
typedef long int CLAPACK_logical;
typedef short int CLAPACK_shortlogical;
typedef char CLAPACK_logical1;
typedef char CLAPACK_integer1;
#if 0	/* Adjust for CLAPACK_integer*8. */
typedef long long CLAPACK_longint;		/* system-dependent */
typedef unsigned long long CLAPACK_ulongint;	/* system-dependent */
#define qbit_clear(a,b)	((a) & ~((CLAPACK_ulongint)1 << (b)))
#define qbit_set(a,b)	((a) |  ((CLAPACK_ulongint)1 << (b)))
#endif

#define TRUE_ (1)
#define FALSE_ (0)

/* I/O stuff */

typedef long int flag;
typedef long int ftnlen;
typedef long int ftnint;

union Multitype {	/* for multiple entry points */
	CLAPACK_integer1 g;
	CLAPACK_shortint h;
	CLAPACK_integer i;
	/* CLAPACK_longint j; */
	CLAPACK_real r;
	CLAPACK_doublereal d;
	CLAPACK_complex c;
	CLAPACK_doublecomplex z;
	};

typedef union Multitype Multitype;

/*typedef long int Long;*/	/* No longer used; formerly in Namelist */

struct Vardesc {	/* for Namelist */
	char *name;
	char *addr;
	ftnlen *dims;
	int  type;
	};
typedef struct Vardesc Vardesc;

struct Namelist {
	char *name;
	Vardesc **vars;
	int nvars;
	};
typedef struct Namelist Namelist;

template<class T> T  abs(T x) {return x >= 0 ? x : -x;} ;
  // inline   T  abs(T x) {return ((x) >= 0 ? (x) : -(x));}
  //inline CLAPACK_doublereal abs( CLAPACK_doublereal x) {return ((x) >= 0 ? (x) : -(x));}
#define dabs(x) (CLAPACK_doublereal)abs(x)
#define min(a,b) ((a) <= (b) ? (a) : (b))
#define max(a,b) ((a) >= (b) ? (a) : (b))
#define dmin(a,b) (CLAPACK_doublereal)min(a,b)
#define dmax(a,b) (CLAPACK_doublereal)max(a,b)
#define bit_test(a,b)	((a) >> (b) & 1)
#define bit_clear(a,b)	((a) & ~((CLAPACK_uinteger)1 << (b)))
#define bit_set(a,b)	((a) |  ((CLAPACK_uinteger)1 << (b)))

/* procedure parameter types for -A and -C++ */

#define F2C_proc_par_types 1
#ifdef __cplusplus
typedef int /* Unknown procedure type */ (*U_fp)(...);
typedef CLAPACK_shortint (*J_fp)(...);
typedef CLAPACK_integer (*I_fp)(...);
typedef CLAPACK_real (*R_fp)(...);
typedef CLAPACK_doublereal (*D_fp)(...), (*E_fp)(...);
typedef /* Complex */ void (*C_fp)(...);
typedef /* Double Complex */ void (*Z_fp)(...);
typedef CLAPACK_logical (*L_fp)(...);
typedef CLAPACK_shortlogical (*K_fp)(...);
typedef /* Character */ void (*H_fp)(...);
typedef /* Subroutine */ int (*S_fp)(...);
#else
typedef int /* Unknown procedure type */ (*U_fp)();
typedef CLAPACK_shortint (*J_fp)();
typedef CLAPACK_integer (*I_fp)();
typedef CLAPACK_real (*R_fp)();
typedef CLAPACK_doublereal (*D_fp)(), (*E_fp)();
typedef /* Complex */ void (*C_fp)();
typedef /* Double Complex */ void (*Z_fp)();
typedef CLAPACK_logical (*L_fp)();
typedef CLAPACK_shortlogical (*K_fp)();
typedef /* Character */ void (*H_fp)();
typedef /* Subroutine */ int (*S_fp)();
#endif
/* E_fp is for CLAPACK_real functions when -R is not specified */
typedef void C_f;	/* complex function */
typedef void H_f;	/* character function */
typedef void Z_f;	/* double complex function */
typedef CLAPACK_doublereal E_f;	/* CLAPACK_real function with -R not specified */

/* undef any lower-case symbols that your C compiler predefines, e.g.: */

#ifndef Skip_f2c_Undefs
#undef cray
#undef gcos
#undef mc68010
#undef mc68020
#undef mips
#undef pdp11
#undef sgi
#undef sparc
#undef sun
#undef sun2
#undef sun3
#undef sun4
#undef u370
#undef u3b
#undef u3b2
#undef u3b5
#undef unix
#undef vax
#endif
#endif

/* If you are using a C++ compiler, append the following to f2c.h
   for compiling libF77 and libI77. */

#ifdef __cplusplus
extern "C" {
int abort_(void);
//  double c_abs(CLAPACK_complex *);
//  void c_cos(CLAPACK_complex *, CLAPACK_complex *);
//  void c_div(CLAPACK_complex *, CLAPACK_complex *, CLAPACK_complex *);
//  void c_exp(CLAPACK_complex *, CLAPACK_complex *);
//  void c_log(CLAPACK_complex *, CLAPACK_complex *);
//  void c_sin(CLAPACK_complex *, CLAPACK_complex *);
//  void c_sqrt(CLAPACK_complex *, CLAPACK_complex *);
double d_abs(double *);
double d_acos(double *);
double d_asin(double *);
double d_atan(double *);
double d_atn2(double *, double *);
  // void d_cnjg(CLAPACK_doublecomplex *, CLAPACK_doublecomplex *);
double d_cos(double *);
double d_cosh(double *);
double d_dim(double *, double *);
double d_exp(double *);
  // double d_imag(CLAPACK_doublecomplex *);
double d_int(double *);
double d_lg10(double *);
double d_log(double *);
double d_mod(double *, double *);
double d_nint(double *);
double d_prod(float *, float *);
double d_sign(double *, double *);
double d_sin(double *);
double d_sinh(double *);
double d_sqrt(double *);
double d_tan(double *);
double d_tanh(double *);
double derf_(double *);
double derfc_(double *);
//  CLAPACK_integer do_fio(ftnint *, char *, ftnlen);
//  CLAPACK_integer do_lio(ftnint *, ftnint *, char *, ftnlen);
//  CLAPACK_integer do_uio(ftnint *, char *, ftnlen);
//  CLAPACK_integer e_rdfe(void);
//  CLAPACK_integer e_rdue(void);
//  CLAPACK_integer e_rsfe(void);
//  CLAPACK_integer e_rsfi(void);
//  CLAPACK_integer e_rsle(void);
//  CLAPACK_integer e_rsli(void);
//  CLAPACK_integer e_rsue(void);
//  CLAPACK_integer e_wdfe(void);
//  CLAPACK_integer e_wdue(void);
//  CLAPACK_integer e_wsfe(void);
//  CLAPACK_integer e_wsfi(void);
//  CLAPACK_integer e_wsle(void);
//  CLAPACK_integer e_wsli(void);
//  CLAPACK_integer e_wsue(void);
int ef1asc_(ftnint *, ftnlen *, ftnint *, ftnlen *);
CLAPACK_integer ef1cmc_(ftnint *, ftnlen *, ftnint *, ftnlen *);
  // double erf(double);
double erf_(float *);
  // double erfc(double);
double erfc_(float *);
void exit_(CLAPACK_integer *rc);
//  CLAPACK_integer f_back(alist *);
//  CLAPACK_integer f_clos(cllist *);
//  CLAPACK_integer f_end(alist *);
double f__cabs(double CLAPACK_real, double imag);
void f_exit(void);

void getenv_(char *, char *, ftnlen, ftnlen);
short h_abs(short *);
short h_dim(short *, short *);
short h_dnnt(double *);
short h_indx(char *, char *, ftnlen, ftnlen);
short h_len(char *, ftnlen);
short h_mod(short *, short *);
short h_nint(float *);
short h_sign(short *, short *);
short hl_ge(char *, char *, ftnlen, ftnlen);
short hl_gt(char *, char *, ftnlen, ftnlen);
short hl_le(char *, char *, ftnlen, ftnlen);
short hl_lt(char *, char *, ftnlen, ftnlen);
CLAPACK_integer i_abs(CLAPACK_integer *);
CLAPACK_integer i_dim(CLAPACK_integer *, CLAPACK_integer *);
CLAPACK_integer i_dnnt(double *);
CLAPACK_integer i_indx(char *, char *, ftnlen, ftnlen);
CLAPACK_integer i_len(char *, ftnlen);
CLAPACK_integer i_mod(CLAPACK_integer *, CLAPACK_integer *);
CLAPACK_integer i_nint(float *);
CLAPACK_integer i_sign(CLAPACK_integer *, CLAPACK_integer *);
  // CLAPACK_integer iargc_(void);
ftnlen l_ge(char *, char *, ftnlen, ftnlen);
ftnlen l_gt(char *, char *, ftnlen, ftnlen);
ftnlen l_le(char *, char *, ftnlen, ftnlen);
ftnlen l_lt(char *, char *, ftnlen, ftnlen);
  // void pow_ci(CLAPACK_complex *, CLAPACK_complex *, CLAPACK_integer *);
double pow_dd(double *, double *);
double pow_di(double *, CLAPACK_integer *);
short pow_hh(short *, CLAPACK_shortint *);
CLAPACK_integer pow_ii(CLAPACK_integer *, CLAPACK_integer *);
double pow_ri(float *, CLAPACK_integer *);
//  void pow_zi(CLAPACK_doublecomplex *, CLAPACK_doublecomplex *, CLAPACK_integer *);
//  void pow_zz(CLAPACK_doublecomplex *, CLAPACK_doublecomplex *, CLAPACK_doublecomplex *);
double r_abs(float *);
double r_acos(float *);
double r_asin(float *);
double r_atan(float *);
double r_atn2(float *, float *);
  // void r_cnjg(CLAPACK_complex *, CLAPACK_complex *);
double r_cos(float *);
double r_cosh(float *);
double r_dim(float *, float *);
double r_exp(float *);
  // double r_imag(CLAPACK_complex *);
double r_int(float *);
double r_lg10(float *);
double r_log(float *);
double r_mod(float *, float *);
double r_nint(float *);
double r_sign(float *, float *);
double r_sin(float *);
double r_sinh(float *);
double r_sqrt(float *);
double r_tan(float *);
double r_tanh(float *);
void s_cat(char *, char **, CLAPACK_integer *, CLAPACK_integer *, ftnlen);
CLAPACK_integer s_cmp(char *, char *, ftnlen, ftnlen);
void s_copy(char *, char *, ftnlen, ftnlen);
int s_paus(char *, ftnlen);
//  CLAPACK_integer s_rdfe(cilist *);
//  CLAPACK_integer s_rdue(cilist *);
//  CLAPACK_integer s_rnge(char *, CLAPACK_integer, char *, CLAPACK_integer);
//  CLAPACK_integer s_rsfe(cilist *);
//  CLAPACK_integer s_rsfi(icilist *);
//  CLAPACK_integer s_rsle(cilist *);
//  CLAPACK_integer s_rsli(icilist *);
//  CLAPACK_integer s_rsne(cilist *);
//  CLAPACK_integer s_rsni(icilist *);
//  CLAPACK_integer s_rsue(cilist *);
int s_stop(char *, ftnlen);
//  CLAPACK_integer s_wdfe(cilist *);
//  CLAPACK_integer s_wdue(cilist *);
//  CLAPACK_integer s_wsfe(cilist *);
//  CLAPACK_integer s_wsfi(icilist *);
//  CLAPACK_integer s_wsle(cilist *);
//  CLAPACK_integer s_wsli(icilist *);
//  CLAPACK_integer s_wsne(cilist *);
//  CLAPACK_integer s_wsni(icilist *);
//  CLAPACK_integer s_wsue(cilist *);
void sig_die(char *, int);
CLAPACK_integer signal_(CLAPACK_integer *, void (*)(int));
CLAPACK_integer system_(char *, ftnlen);
//  double z_abs(CLAPACK_doublecomplex *);
//  void z_cos(CLAPACK_doublecomplex *, CLAPACK_doublecomplex *);
//  void z_div(CLAPACK_doublecomplex *, CLAPACK_doublecomplex *, CLAPACK_doublecomplex *);
//  void z_exp(CLAPACK_doublecomplex *, CLAPACK_doublecomplex *);
//  void z_log(CLAPACK_doublecomplex *, CLAPACK_doublecomplex *);
//  void z_sin(CLAPACK_doublecomplex *, CLAPACK_doublecomplex *);
//  void z_sqrt(CLAPACK_doublecomplex *, CLAPACK_doublecomplex *);
void  waitpause(Sigarg);
void  s_1paus(FILE *fin);
char* F77_aloc(CLAPACK_integer Len, char *whence);

}
#endif


/* CLAPACK 3.0 BLAS wrapper macros
 * Feb 5, 2000
 */


#ifndef __CLAPACK_H
#define __CLAPACK_H

int dstebz_(char *range, char *order, CLAPACK_integer *n, CLAPACK_doublereal 
	*vl, CLAPACK_doublereal *vu, CLAPACK_integer *il, CLAPACK_integer *iu, CLAPACK_doublereal *abstol, 
	CLAPACK_doublereal *d__, CLAPACK_doublereal *e, CLAPACK_integer *m, CLAPACK_integer *nsplit, 
	CLAPACK_doublereal *w, CLAPACK_integer *iblock, CLAPACK_integer *isplit, CLAPACK_doublereal *work, 
	    CLAPACK_integer *iwork, CLAPACK_integer *info);
int dlaebz_(CLAPACK_integer *ijob, CLAPACK_integer *nitmax, CLAPACK_integer *n, 
	CLAPACK_integer *mmax, CLAPACK_integer *minp, CLAPACK_integer *nbmin, CLAPACK_doublereal *abstol, 
	CLAPACK_doublereal *reltol, CLAPACK_doublereal *pivmin, CLAPACK_doublereal *d__, CLAPACK_doublereal *
	e, CLAPACK_doublereal *e2, CLAPACK_integer *nval, CLAPACK_doublereal *ab, CLAPACK_doublereal *c__, 
	CLAPACK_integer *mout, CLAPACK_integer *nab, CLAPACK_doublereal *work, CLAPACK_integer *iwork, 
	    CLAPACK_integer *info);

int dstein_(CLAPACK_integer *n, CLAPACK_doublereal *d__, CLAPACK_doublereal *e,
	    CLAPACK_integer *m, CLAPACK_doublereal *w, CLAPACK_integer *iblock, CLAPACK_integer *isplit,
	    CLAPACK_doublereal *z__, CLAPACK_integer *ldz, CLAPACK_doublereal *work, CLAPACK_integer *iwork,
	    CLAPACK_integer *ifail, CLAPACK_integer *info);

int dlagtf_(CLAPACK_integer *, CLAPACK_doublereal *, CLAPACK_doublereal *,
	     CLAPACK_doublereal *, CLAPACK_doublereal *, CLAPACK_doublereal *, CLAPACK_doublereal *, CLAPACK_integer *
	    , CLAPACK_integer *);
int dlagts_(CLAPACK_integer *job, CLAPACK_integer *n, CLAPACK_doublereal *a, 
	    CLAPACK_doublereal *b, CLAPACK_doublereal *c__, CLAPACK_doublereal *d__, CLAPACK_integer *in, 
	    CLAPACK_doublereal *y, CLAPACK_doublereal *tol, CLAPACK_integer *info);
int dlarnv_(CLAPACK_integer *, CLAPACK_integer *, CLAPACK_integer *, CLAPACK_doublereal *);
int dlaruv_(CLAPACK_integer *, CLAPACK_integer *, CLAPACK_doublereal *);

int xerbla_(char *srname, CLAPACK_integer *info);
CLAPACK_doublereal dlamch_(char *cmach);
int dlamc1_(CLAPACK_integer *beta, CLAPACK_integer *t, CLAPACK_logical *rnd, CLAPACK_logical 
	*ieee1);
int dlamc2_(CLAPACK_integer *beta, CLAPACK_integer *t, CLAPACK_logical *rnd, 
	CLAPACK_doublereal *eps, CLAPACK_integer *emin, CLAPACK_doublereal *rmin, CLAPACK_integer *emax, 
	    CLAPACK_doublereal *rmax);
CLAPACK_doublereal dlamc3_(CLAPACK_doublereal *a, CLAPACK_doublereal *b);
int dlamc4_(CLAPACK_integer *emin, CLAPACK_doublereal *start, CLAPACK_integer *base);
int dlamc5_(CLAPACK_integer *beta, CLAPACK_integer *p, CLAPACK_integer *emin, 
	    CLAPACK_logical *ieee, CLAPACK_integer *emax, CLAPACK_doublereal *rmax);

CLAPACK_integer ilaenv_(CLAPACK_integer *ispec, char *name__, char *opts, CLAPACK_integer *n1, 
	CLAPACK_integer *n2, CLAPACK_integer *n3, CLAPACK_integer *n4, ftnlen name_len, ftnlen 
				      opts_len);

CLAPACK_integer ieeeck_(CLAPACK_integer *ispec, CLAPACK_real *zero, CLAPACK_real *one);

CLAPACK_logical lsame_(char *ca, char *cb);






/* BLAS prototypes */
int dcopy_(CLAPACK_integer *n, CLAPACK_doublereal *dx, CLAPACK_integer *incx, 
       CLAPACK_doublereal *dy, CLAPACK_integer *incy);
CLAPACK_doublereal ddot_(CLAPACK_integer *n, CLAPACK_doublereal *dx, CLAPACK_integer *incx, CLAPACK_doublereal *dy, 
		 CLAPACK_integer *incy);
CLAPACK_integer idamax_(CLAPACK_integer *, CLAPACK_doublereal *, CLAPACK_integer *);
    extern CLAPACK_integer idamax_(CLAPACK_integer *, CLAPACK_doublereal *, CLAPACK_integer *);
CLAPACK_doublereal dnrm2_(CLAPACK_integer *n, CLAPACK_doublereal *x, CLAPACK_integer *incx);
int dscal_(CLAPACK_integer *n, CLAPACK_doublereal *da, CLAPACK_doublereal *dx, 
	   CLAPACK_integer *incx);
int daxpy_(CLAPACK_integer *n, CLAPACK_doublereal *da, CLAPACK_doublereal *dx, 
	   CLAPACK_integer *incx, CLAPACK_doublereal *dy, CLAPACK_integer *incy);
CLAPACK_doublereal dasum_(CLAPACK_integer *n, CLAPACK_doublereal *dx, CLAPACK_integer *incx);

#endif /* __CLAPACK_H */


/* You may need to adjust the definition of signal1 to supply a */
/* cast to the correct argument type.  This detail is system- and */
/* compiler-dependent.   The #define below assumes signal.h declares */
/* type SIG_PF for the signal function's second argument. */

/* For some C++ compilers, "#define Sigarg_t ..." may be appropriate. */

#include <signal.h>

#ifndef Sigret_t
#define Sigret_t void
#endif
#ifndef Sigarg_t
#define Sigarg_t int
#endif /*Sigarg_t*/

#ifdef USE_SIG_PF	/* compile with -DUSE_SIG_PF under IRIX */
#define sig_pf SIG_PF
#else
typedef Sigret_t (*sig_pf)(Sigarg_t);
#endif

#define signal1(a,b) signal(a,(sig_pf)b)



#ifndef SEEK_SET
#define SEEK_SET 0
#define SEEK_CUR 1
#define SEEK_END 2
#endif

#ifdef MSDOS
#ifndef NON_UNIX_STDIO
#define NON_UNIX_STDIO
#endif
#endif

#ifdef UIOLEN_int
typedef int uiolen;
#else
typedef long uiolen;
#endif

/*units*/
//  typedef struct
//  {	FILE *ufd;	/*0=unconnected*/
//  	char *ufnm;
//  #ifndef MSDOS
//  	long uinode;
//  	int udev;
//  #endif
//  	int url;	/*0=sequential*/
//  	flag useek;	/*true=can backspace, use dir, ...*/
//  	flag ufmt;
//  	flag urw;	/* (1 for can read) | (2 for can write) */
//  	flag ublnk;
//  	flag uend;
//  	flag uwrt;	/*last io was write*/
//  	flag uscrtch;
//  } unit;

//  flag f__init;
//  cilist *f__elist;	/*active external io list*/
//  flag f__reading,f__external,f__sequential,f__formatted;
//  #undef Void
//  #ifdef KR_headers
//  #define Void /*void*/
//  int (*f__getn)();	/* for formatted input */
//  void (*f__putn)();	/* for formatted output */
//  void x_putc();
//  long f__inode();
//  VOID sig_die();
//  int (*f__donewrec)(), t_putc(), x_wSL();
//  int c_sfe(), err__fl(), xrd_SL(), f__putbuf();
//  #else
//  #define Void void
//  #ifdef __cplusplus
//  extern "C" {
//  #endif
//  int (*f__getn)(void);	/* for formatted input */
//  void (*f__putn)(int);	/* for formatted output */
//  void x_putc(int);
//  long f__inode(char*,int*);
//  void sig_die(char*,int);
//  void f__fatal(int,char*);
//  int t_runc(alist*);
//  int f__nowreading(unit*), f__nowwriting(unit*);
//  int fk_open(int,int,ftnint);
//  int en_fio(void);
//  void f_init(void);
//  int (*f__donewrec)(void), t_putc(int), x_wSL(void);
//  void b_char(char*,char*,ftnlen), g_char(char*,ftnlen,char*);
//  int c_sfe(cilist*), z_rnew(void);
//  int isatty(int);
//  int err__fl(int,int,char*);
//  int xrd_SL(void);
//  int f__putbuf(int);
//  #ifdef __cplusplus
//  	}
//  #endif
//  #endif

//  #define err(f,m,s) {if(f) errno= m; else f__fatal(m,s); return(m);}
//  #define errfl(f,m,s) return err__fl((int)f,m,s)

//  /*Table sizes*/
//  #define MXUNIT 100

//  #define WRITE	1
//  #define READ	2
//  #define SEQ	3
//  #define DIR	4
//  #define FMT	5
//  #define UNF	6
//  #define EXT	7
//  #define INT	8

//  #define buf_end(x) (x->_flag & _IONBF ? x->_ptr : x->_base + BUFSIZ)

//  /*	copy of ftypes from the compiler */
//  /* variable types
//   * numeric assumptions:
//   *	int < CLAPACK_reals < complexes
//   *	TYDREAL-TYREAL = TYDCOMPLEX-TYCOMPLEX
//   */

//  /* 0-10 retain their old (pre LOGICAL*1, etc.) */
//  /* values to allow mixing old and new objects. */

//  #define TYUNKNOWN 0
//  #define TYADDR 1
//  #define TYSHORT 2
//  #define TYLONG 3
//  #define TYREAL 4
//  #define TYDREAL 5
//  #define TYCOMPLEX 6
//  #define TYDCOMPLEX 7
//  #define TYLOGICAL 8
//  #define TYCHAR 9
//  #define TYSUBR 10
//  #define TYINT1 11
//  #define TYLOGICAL1 12
//  #define TYLOGICAL2 13
//  #ifdef Allow_TYQUAD
//  #undef TYQUAD
//  #define TYQUAD 14
//  #endif

//  #define	LINTW	24
//  #define	LINE	80
//  #define	LLOGW	2
//  #ifdef Old_list_output
//  #define	LLOW	1.0
//  #define	LHIGH	1.e9
//  #define	LEFMT	" %# .8E"
//  #define	LFFMT	" %# .9g"
//  #else
//  #define	LGFMT	"%.9G"
//  #endif
//  /* LEFBL 20 should suffice; 24 overcomes a NeXT bug. */
//  #define	LEFBL	24

//  typedef union
//  {
//  	char	flchar;
//  	short	flshort;
//  	ftnint	flint;
//  #ifdef Allow_TYQUAD
//  	CLAPACK_longint fllongintXS;
//  #endif
//  	CLAPACK_real	flCLAPACK_real;
//  	CLAPACK_doublereal	fldouble;
//  } flex;
//  int f__scale;
//  #ifdef KR_headers
//  int (*f__lioproc)(), (*l_getc)(), (*l_ungetc)();
//  int l_read(), l_write();
//  #else
//  #ifdef __cplusplus
//  extern "C" {
//  #endif
//  int (*f__lioproc)(ftnint*, char*, ftnlen, ftnint);
//  int l_write(ftnint*, char*, ftnlen, ftnint);
//  void x_wsne(cilist*);
//  int c_le(cilist*), (*l_getc)(void), (*l_ungetc)(int,FILE*);
//  int l_read(ftnint*,char*,ftnlen,ftnint);
//  CLAPACK_integer e_rsle(void), e_wsle(void), s_wsne(cilist*);
//  int z_rnew(void);
//  #ifdef __cplusplus
//  	}
//  #endif
//  #endif

//  ftnint L_len;

//  struct syl
//  {	int op;
//  	int p1;
//  	union { int i[2]; char *s;} p2;
//  	};
//  //  #define RET1 1
//  //  #define REVERT 2
//  //  #define GOTO 3
//  //  #define X 4
//  //  #define SLASH 5
//  //  #define STACK 6
//  //  #define I 7
//  //  #define ED 8
//  //  #define NED 9
//  //  #define IM 10
//  //  #define APOS 11
//  //  #define H 12
//  //  #define TL 13
//  //  #define TR 14
//  //  #define T 15
//  //  #define COLON 16
//  //  #define S 17
//  //  #define SP 18
//  //  #define SS 19
//  //  #define P 20
//  //  #define BN 21
//  //  #define BZ 22
//  //  #define F 23
//  //  #define E 24
//  //  #define EE 25
//  //  #define D 26
//  //  #define G 27
//  //  #define GE 28
//  //  #define L 29
//  //  #define A 30
//  //  #define AW 31
//  //  #define O 32
//  //  #define NONL 33
//  //  #define OM 34
//  //  #define Z 35
//  //  #define ZM 36
//  int f__pc,f__parenlvl,f__revloc;
//  typedef union
//  {	CLAPACK_real pf;
//  	CLAPACK_doublereal pd;
//  } ufloat;
//  typedef union
//  {	short is;
//  #ifndef KR_headers
//  	signed
//  #endif
//  		char ic;
//  	CLAPACK_integer il;
//  #ifdef Allow_TYQUAD
//  	longint ili;
//  #endif
//  } Uint;
//  #ifdef KR_headers
//  int (*f__doed)(),(*f__doned)();
//  int (*f__dorevert)();
//  int rd_ed(),rd_ned();
//  int w_ed(),w_ned();
//  #else
//  #ifdef __cplusplus
//  extern "C" {
//  #endif
//  int (*f__doed)(struct syl*, char*, ftnlen),(*f__doned)(struct syl*);
//  int (*f__dorevert)(void);
//  void fmt_bg(void);
//  int pars_f(char*);
//  int rd_ed(struct syl*, char*, ftnlen),rd_ned(struct syl*);
//  int w_ed(struct syl*, char*, ftnlen),w_ned(struct syl*);
//  int wrt_E(ufloat*, int, int, int, ftnlen);
//  int wrt_F(ufloat*, int, int, ftnlen);
//  int wrt_L(Uint*, int, ftnlen);
//  #ifdef __cplusplus
//  	}
//  #endif
//  #endif
//  flag f__cblank,f__cplus,f__workdone, f__nonl;
//  char *f__fmtbuf;
//  #define GET(x) if((x=(*f__getn)())<0) return(x)
//  #define VAL(x) (x!='\n'?x:' ')
//  #define PUT(x) (*f__putn)(x)
//  int f__cursor;

//  #undef TYQUAD
//  #ifndef Allow_TYQUAD
//  #undef longint
//  #define longint long
//  #else
//  #define TYQUAD 14
//  #endif


//  char *f__icvt(longint, int*, int*, int);

} // namespace LinAlg
